from Products.Archetypes.public import *
from Products.Archetypes.atapi import *

try:
    from Products.ATContentTypes.content.file import ATFile, ATFileSchema
except ImportError:
    # For ATCT 0.2 compatibility
    from Products.ATContentTypes.types.ATFile import ATFile
    from Products.ATContentTypes.types.schemata import ATFileSchema

try :
    from Products.CMFCore import permissions
except ImportError:
    # For CMF 1.4 compatibility
    from Products.CMFCore import CMFCorePermissions
    permissions = CMFCorePermissions
    
from Products.CMFCore.utils import getToolByName
from AccessControl import ClassSecurityInfo
from config import *


schema = ATFileSchema + Schema((

    TextField('bodyBefore',
              required = False,
              searchable = True,
              allowable_content_types = ('text/html',),
              default_output_type = 'text/x-html-safe',
              widget=RichWidget(description='Explanatory text, before applet.',
                                description_msgid ='desc_description_before',
                                label='Text',
                                label_msgid ='label_description',                                
                                i18n_domain = 'Freemind',
                                rows=15,),

             ),

    TextField('bodyAfter',
              required = False,
              searchable = True,
              allowable_content_types = ('text/html',),
              default_output_type = 'text/x-html-safe',
              widget=RichWidget(description='Explanatory text, after applet.',
                                description_msgid ='desc_description_after',
                                label='Text',
                                label_msgid ='label_description',                                
                                i18n_domain = 'Freemind',
                                rows=15,),

             ),

    StringField('width',
                 required = False,
                 searchable = False,
                 default = '100%',
                 widget=StringWidget(label ='Width', modes= ('view','edit',),
                                      label_msgid ='label_width',
                                      description = 'Width of the applet. Pixels or %',
                                      description_msgid ="desc_width",
                                      i18n_domain='Freemind'),
                 ),
    
    StringField('height',
                 required = False,
                 searchable = False,
                 default = DEFAULT_HEIGHT,
                 widget=StringWidget(label ='Height', modes= ('view','edit'),
                                      label_msgid ='label_height',
                                      description = 'Height of the applet. Pixels or %',
                                      description_msgid ="desc_height",
                                      i18n_domain='Freemind'),
                 ),

    ))


class Freemind(ATFile):
    """A Freemind file"""

    __implements__ = (getattr(ATFile,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)
    
    schema = schema
    archetype_name = 'Freemind map'
    meta_type = 'FreemindFile'
    portal_type = 'FreemindFile'
    content_icon = 'freemind_applet.gif'
    immediate_view = 'freemindfile_view'
    default_view   = 'freemindfile_view'
    typeDescription= "Freemind map"
    typeDescMsgId  = 'description_edit_freemind_file'
    assocFileExt   = ('mm',)

    global_allow = True

    security = ClassSecurityInfo()

    security.declareProtected(permissions.ModifyPortalContent, 'setFile')
    
    def setFile(self, value, **kwargs):
        """Saves file and stores freemind applet informations (size etc)"""
        ATFile.setFile(self, value, **kwargs)

    security.declarePublic('getIcon')
    def getIcon(self, relative_to_portal=0):
        """Returns icon for Freemind file"""
        icon = self.content_icon

        if relative_to_portal:
            return icon
        else:
            utool = getToolByName( self, 'portal_url' )
            # Relative to REQUEST['BASEPATH1']
            res = utool(relative=1) + '/' + icon
            while res[:1] == '/':
                res = res[1:]
            return res

registerType(Freemind)
